DECLARE FUNCTION Oct2Hex$ (X$)
DECLARE FUNCTION Oct2Dec$ (X$)
DECLARE FUNCTION Bin2Dec$ (X$)
DECLARE FUNCTION Bin2Hex$ (X$)
DECLARE FUNCTION Hex2Oct$ (X$)
DECLARE FUNCTION Hex2Bin$ (X$)
DECLARE FUNCTION Bin2Oct$ (X$)
'Dan Owen "Standard Number Base Converter"

DECLARE FUNCTION Dec2Bin$ (X$)
DECLARE FUNCTION Dec2Hex$ (X$)
DECLARE FUNCTION Dec2Oct$ (X$)
DECLARE FUNCTION Oct2Bin$ (X$)
DECLARE FUNCTION Hex2Dec$ (X$)

ABetterPlace:
CLS

LOCATE 25, 1: PRINT "Type " + CHR$(34) + "Exit" + CHR$(34) + " to exit."
LOCATE 1, 1

Basetype = 0
PRINT "Enter number: ": LOCATE 1, 15: COLOR 7: INPUT "", Tempp$
IF LCASE$(Tempp$) = "exit" THEN
   COLOR 7: END
END IF

Tempp$ = UCASE$(Tempp$)

COLOR 7: PRINT "Convert from (Binary, Octal, Decimal, Hexadecimal): "
COLOR 15: LOCATE 2, 15: PRINT "B": LOCATE 2, 23: PRINT "O"
LOCATE 2, 30: PRINT "D": LOCATE 2, 39: PRINT "H": COLOR 7: LOCATE 2, 53
INPUT "", Tempp2$: IF LCASE$(Tempp2$) = "exit" THEN END

IF LCASE$(Tempp2$) = "b" THEN
   StrBin$ = Tempp$: StrOct$ = Bin2Oct$(Tempp$)
   StrHex$ = Bin2Hex$(Tempp$): StrDec$ = Bin2Dec$(Tempp$)
ELSEIF LCASE$(Tempp2$) = "o" THEN
   StrBin$ = Oct2Bin$(Tempp$): StrOct$ = Tempp$
   StrDec$ = Oct2Dec$(Tempp$): StrHex$ = Oct2Hex$(Tempp$)
ELSEIF LCASE$(Tempp2$) = "d" THEN
   StrBin$ = Dec2Bin$(Tempp$): StrOct$ = Dec2Oct$(Tempp$)
   StrDec$ = Tempp$: StrHex$ = Dec2Hex$(Tempp$)
ELSEIF LCASE$(Tempp2$) = "h" THEN
   StrDec$ = Hex2Dec$(Tempp$): StrHex$ = Tempp$
   StrBin$ = Hex2Bin$(Tempp$): StrOct$ = Hex2Oct$(Tempp$)
END IF


PRINT "": COLOR 7
PRINT "     Base Name: Calculated Value"
PRINT "   "
PRINT "        Binary: " + StrBin$
PRINT "         Octal: " + StrOct$
PRINT "       Decimal: " + StrDec$
PRINT "   Hexadecimal: " + StrHex$

PRINT "": PRINT "Press any key to continue...": DO: LOOP WHILE INKEY$ = ""
GOTO ABetterPlace

FUNCTION Bin2Dec$ (X$)
Bin2Dec$ = Hex2Dec$(Bin2Hex$(X$))
END FUNCTION

FUNCTION Bin2Hex$ (X$)

D = 1
NV$ = ""

TestHexOut:
   Too$ = STR$(LEN(X$) / 4)
   Search$ = ".": Where = INSTR(Too$, Search$)
   IF Where THEN
      X$ = "0" + X$
      GOTO TestHexOut
   END IF
       
FomeBack:
IF D <= LEN(X$) THEN
   'PRINT MID$(X$, D, 3)
   IF MID$(X$, D, 4) = "0000" THEN NV$ = NV$ + "0"
   IF MID$(X$, D, 4) = "0001" THEN NV$ = NV$ + "1"
   IF MID$(X$, D, 4) = "0010" THEN NV$ = NV$ + "2"
   IF MID$(X$, D, 4) = "0011" THEN NV$ = NV$ + "3"
   IF MID$(X$, D, 4) = "0100" THEN NV$ = NV$ + "4"
   IF MID$(X$, D, 4) = "0101" THEN NV$ = NV$ + "5"
   IF MID$(X$, D, 4) = "0110" THEN NV$ = NV$ + "6"
   IF MID$(X$, D, 4) = "0111" THEN NV$ = NV$ + "7"
   IF MID$(X$, D, 4) = "1000" THEN NV$ = NV$ + "8"
   IF MID$(X$, D, 4) = "1001" THEN NV$ = NV$ + "9"
   IF MID$(X$, D, 4) = "1010" THEN NV$ = NV$ + "A"
   IF MID$(X$, D, 4) = "1011" THEN NV$ = NV$ + "B"
   IF MID$(X$, D, 4) = "1100" THEN NV$ = NV$ + "C"
   IF MID$(X$, D, 4) = "1101" THEN NV$ = NV$ + "D"
   IF MID$(X$, D, 4) = "1110" THEN NV$ = NV$ + "E"
   IF MID$(X$, D, 4) = "1111" THEN NV$ = NV$ + "F"

   D = D + 4
   GOTO FomeBack
END IF

FomeBack2:
IF MID$(NV$, 1, 1) = "0" THEN
   NV$ = MID$(NV$, 2, LEN(NV$) - 1)
   GOTO FomeBack2
END IF

IF LEN(NV$) = 0 THEN NV$ = "0"
Bin2Hex$ = NV$


END FUNCTION

FUNCTION Bin2Oct$ (X$)

D = 1
NV$ = ""

TestOctOut:
   Too$ = STR$(LEN(X$) / 3)
   Search$ = ".": Where = INSTR(Too$, Search$)
   IF Where THEN
      X$ = "0" + X$
      GOTO TestOctOut
   END IF
        
omeBack:
IF D <= LEN(X$) THEN
   'PRINT MID$(X$, D, 3)
   IF MID$(X$, D, 3) = "000" THEN NV$ = NV$ + "0"
   IF MID$(X$, D, 3) = "001" THEN NV$ = NV$ + "1"
   IF MID$(X$, D, 3) = "010" THEN NV$ = NV$ + "2"
   IF MID$(X$, D, 3) = "011" THEN NV$ = NV$ + "3"
   IF MID$(X$, D, 3) = "100" THEN NV$ = NV$ + "4"
   IF MID$(X$, D, 3) = "101" THEN NV$ = NV$ + "5"
   IF MID$(X$, D, 3) = "110" THEN NV$ = NV$ + "6"
   IF MID$(X$, D, 3) = "111" THEN NV$ = NV$ + "7"
   D = D + 3
   GOTO omeBack
END IF

omeBack2:
IF MID$(NV$, 1, 1) = "0" THEN
   NV$ = MID$(NV$, 2, LEN(NV$) - 1)
   GOTO omeBack2
END IF

IF LEN(NV$) = 0 THEN NV$ = "0"
Bin2Oct$ = NV$

END FUNCTION

FUNCTION Dec2Bin$ (X$)
Dec2Bin$ = Oct2Bin$(Dec2Oct$(X$))
END FUNCTION

FUNCTION Dec2Hex$ (X$)
Dec2Hex$ = HEX$(VAL(X$))
END FUNCTION

FUNCTION Dec2Oct$ (X$)
Dec2Oct$ = OCT$(VAL(X$))
END FUNCTION

FUNCTION Hex2Bin$ (X$)
D = 1
NV$ = ""

ComeBackb:
IF D <= LEN(X$) THEN
   'PRINT MID$(X$, D, 1)
   IF MID$(X$, D, 1) = "0" THEN NV$ = NV$ + "0000"
   IF MID$(X$, D, 1) = "1" THEN NV$ = NV$ + "0001"
   IF MID$(X$, D, 1) = "2" THEN NV$ = NV$ + "0010"
   IF MID$(X$, D, 1) = "3" THEN NV$ = NV$ + "0011"
   IF MID$(X$, D, 1) = "4" THEN NV$ = NV$ + "0100"
   IF MID$(X$, D, 1) = "5" THEN NV$ = NV$ + "0101"
   IF MID$(X$, D, 1) = "6" THEN NV$ = NV$ + "0110"
   IF MID$(X$, D, 1) = "7" THEN NV$ = NV$ + "0111"
   IF MID$(X$, D, 1) = "8" THEN NV$ = NV$ + "1000"
   IF MID$(X$, D, 1) = "9" THEN NV$ = NV$ + "1001"
   IF MID$(X$, D, 1) = "A" THEN NV$ = NV$ + "1010"
   IF MID$(X$, D, 1) = "B" THEN NV$ = NV$ + "1011"
   IF MID$(X$, D, 1) = "C" THEN NV$ = NV$ + "1100"
   IF MID$(X$, D, 1) = "D" THEN NV$ = NV$ + "1101"
   IF MID$(X$, D, 1) = "E" THEN NV$ = NV$ + "1110"
   IF MID$(X$, D, 1) = "F" THEN NV$ = NV$ + "1111"

   D = D + 1
   GOTO ComeBackb
END IF

ComeBack2b:
IF MID$(NV$, 1, 1) = "0" THEN
   NV$ = MID$(NV$, 2, LEN(NV$) - 1)
   GOTO ComeBack2b
END IF

IF LEN(NV$) = 0 THEN NV$ = "0"
Hex2Bin$ = NV$

END FUNCTION

FUNCTION Hex2Dec$ (X$)
X$ = UCASE$(X$)        'Captialize all letters in the number

B$ = ""
E = 16
Dig$ = MID$(X$, LEN(X$), 1)         'Calculate first digit

GOSUB Digs

F = 1 * VAL(Dig$)
D = 1

G:                              'Calculate the rest of the digits
IF D < LEN(X$) THEN
    Dig$ = MID$(X$, LEN(X$) - D, 1)
    GOSUB Digs
    I = 1
    E = 16
    GOSUB H
    F = F + (E * VAL(Dig$))
    D = D + 1
    GOTO G
END IF
A$ = STR$(F)
A$ = MID$(A$, 2, LEN(A$) - 1)

IF VAL(A$) > 2147483647 THEN A$ = "(Error)"
Hex2Dec$ = A$                 'Set return value
EXIT FUNCTION

H:                              'Multiply exponential placement for
IF I < D THEN                   'other digits.
    E = E * 16
    I = I + 1
    GOTO H
END IF
RETURN


Digs:                           'Conversion Cypher

IF Dig$ = "A" THEN
    Dig$ = "10"
ELSEIF Dig$ = "B" THEN
    Dig$ = "11"
ELSEIF Dig$ = "C" THEN
    Dig$ = "12"
ELSEIF Dig$ = "D" THEN
    Dig$ = "13"
ELSEIF Dig$ = "E" THEN
    Dig$ = "14"
ELSEIF Dig$ = "F" THEN
    Dig$ = "15"
END IF
RETURN
END FUNCTION

FUNCTION Hex2Oct$ (X$)
Hex2Oct$ = Bin2Oct$(Hex2Bin$(X$))
END FUNCTION

FUNCTION Oct2Bin$ (X$)

D = 1
NV$ = ""

ComeBack:
IF D <= LEN(X$) THEN
   'PRINT MID$(X$, D, 1)
   IF MID$(X$, D, 1) = "0" THEN NV$ = NV$ + "000"
   IF MID$(X$, D, 1) = "1" THEN NV$ = NV$ + "001"
   IF MID$(X$, D, 1) = "2" THEN NV$ = NV$ + "010"
   IF MID$(X$, D, 1) = "3" THEN NV$ = NV$ + "011"
   IF MID$(X$, D, 1) = "4" THEN NV$ = NV$ + "100"
   IF MID$(X$, D, 1) = "5" THEN NV$ = NV$ + "101"
   IF MID$(X$, D, 1) = "6" THEN NV$ = NV$ + "110"
   IF MID$(X$, D, 1) = "7" THEN NV$ = NV$ + "111"
   D = D + 1
   GOTO ComeBack
END IF

ComeBack2:
IF MID$(NV$, 1, 1) = "0" THEN
   NV$ = MID$(NV$, 2, LEN(NV$) - 1)
   GOTO ComeBack2
END IF

IF LEN(NV$) = 0 THEN NV$ = "0"
Oct2Bin$ = NV$
END FUNCTION




FUNCTION Oct2Dec$ (X21$)
Oct2Dec$ = Hex2Dec$(Oct2Hex$(X21$))
END FUNCTION

FUNCTION Oct2Hex$ (X2$)
X$ = Oct2Hex$(Oct2Bin$(X2$))
END FUNCTION

